#include <mpi.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>



int main(int argc, char **argv)
{
  int       myrank, mysize;
  int       recv_buf[10];
  MPI_Status status;
  MPI_Comm  master;
  char      portname[MPI_MAX_PORT_NAME];

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
  MPI_Comm_size(MPI_COMM_WORLD, &mysize);

  MPI_Comm_get_parent(&master);

  /* open port */
  MPI_Open_port(MPI_INFO_NULL, portname);

  /* pass port to master */
  MPI_Send(portname, MPI_MAX_PORT_NAME, MPI_BYTE, 0, 111, master);

  /* Wait for message from father to stop */
  MPI_Recv(recv_buf, 1, MPI_INT, 0, 999, master, &status);

  /* disconnect and exit */

    MPI_Comm_disconnect(&master);
    MPI_Close_port(portname);

  MPI_Finalize();
}

